#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "pngio.h"

/* this program reads a PNG image and dumps its contents as a 24 bit
   bitmap. It can optionally clip the image using a red pixel. This
   is given by the -r option. */

int main(int argc,char **argv)
{
  char *fn;
  int i;
  unsigned int *data,w,h;
  char *e;
  int ak;
  int find_red= 0;
  int x,y;

  if (argc<2) exit(fprintf(stderr,"usage: %s [-r] image_file.png\n",argv[0]));
  ak= 1;
  if (!strcmp(argv[ak],"-r")) { find_red= 1; ak++; }
  if (ak==argc)
        exit(fprintf(stderr,"usage: %s [-r] image_file.png\n",argv[0]));

  fn= argv[ak];
  e= read_png_image(fn, &w,&h, &data);
  if (e) exit(fprintf(stderr,"png error(%s): %s\n",fn,e));
  int ww,hh;
  ww= w; hh= h;

  if (find_red)
  {
    for(y=0;y<h;y++)
     for(x=0;x<w;x++)
        if ((data[y*w+x]&0xFFffFF)== 0xff0000) { ww=x; hh= y; goto found; }
  }
found:

  printf("  %d | (1<<31), %d,", ww,hh);
  i= 0;
  for(y=0;y<hh;y++)
   for(x=0;x<ww;x++)
  {
     if (i%6==0) printf("\n    ");
     printf("0x%08x,", data[y*w+x]);
     i++;
  }
  printf("\n");
  return 0;
}
