#include <stdint.h>
#include <stdarg.h>
#include <stdlib.h>
#include "gfx.h"

void pop_lis()
{
  gfx_insert(Wreslist, -1, "button", NULL, NULL);
  gfx_insert(Wreslist, -1, "--box", NULL, NULL);
}

static uint32_t co3d= 0xffFFff;

void show_3dbox_color(double a, int shift)
{
  int K;
  unsigned int Z;
  unsigned int W,H,*B,i;
  K= a*255;
  if (K<0) K= 0; if (K>255) K= 255;
  co3d= (co3d & ~(0xff<<shift)) | (K<<shift);
  gfx_canvas_get_buffer(Wcolorout, &W,&H,&B);
  Z= W*H;
  for(i=0;i<Z;i++) B[i]= co3d;
  gfx_canvas_update(Wcolorout, 0,0,W,H);
}


int main()
{
  gfx_event_t ev;
  gfx_init(NULL, 1024, 768,"Resource Editor");
  gfx_SCREEN_0();
  pop_lis();
  gfx_set_selected(Wedit,1);
  while(1)
   if (gfx_event(NULL,&ev))
   switch(ev.type)
   {
   case GFXEV_QUIT: goto done;
   case W3dbox_red:     show_3dbox_color(ev.flo0, 16); break;
   case W3dbox_green:   show_3dbox_color(ev.flo0,  8); break;
   case W3dbox_blue:    show_3dbox_color(ev.flo0,  0); break;
   }
done:
  gfx_close();
  return 0;
}
