
typedef uint32_t R_COLOR;
typedef int  R_DIM;

typedef struct
{
  R_COLOR light, dark, border, start, end;
} R_3DBOX;

typedef struct { int w, h; unsigned char *data; } R_GRAYIMG;
typedef struct { int w, h; unsigned int *data; } R_COLORIMG;

typedef struct
{
  struct { R_COLOR bg; R_COLORIMG cursor; } general;
  struct { R_3DBOX normal, depressed;
           R_COLOR fg;      // foreground for text
           R_DIM iconspc;   // spacing between icon and text
         } button;
  struct { R_GRAYIMG ok, nok;
           R_COLOR fg, bg;
           R_DIM pad_left, pad_mid;
         } checkbox;
  struct { R_GRAYIMG on, off;
           R_COLOR fg, bg;
           R_DIM pad_left, pad_mid;
         } radio;
  struct { R_COLORIMG less, more; 
         } spinner;
  struct { R_COLORIMG normal_button, depressed_button;
           R_COLORIMG ind_start, ind_mid, tro_grad;
         } scrollbar;
  struct { struct { R_COLORIMG tro_start, tro_mid, tro_end,
                    normal_button, depressed_button; } vertical, horizontal;
         } slider;
  struct { R_COLORIMG  file, dir, alert;
           R_COLOR fg, // Foreground color for file selector title
                   bg; // Background color for file selector dialog
           R_DIM  spacing, padding;
           struct { R_DIM spacing, padding, left; } dirstack;
         } fileselector;
  struct { struct { R_DIM padv, spc; R_COLOR hilight, border; } list;
           struct { R_DIM left, right, mid; } pad;
           R_3DBOX normal, depressed;
           R_GRAYIMG button;
           R_COLOR fg;
         } dropdown;
  struct { R_COLOR fg, bg; R_DIM pad; } logview;
  struct { R_COLOR fg, bg; R_DIM spacing; 
           R_COLOR border_color; R_DIM border_width;
             // padding is inside the button, spacing is outside
           R_DIM button_padding, button_spacing;
         } confirm;
  struct { R_DIM hspacing, vspacing, vpadding, hpadding;
         } virtkb;
} RESOURCES;

